# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ConnectedCloudspaceArgs', 'ConnectedCloudspace']

@pulumi.input_type
class ConnectedCloudspaceArgs:
    def __init__(__self__, *,
                 cloudspace_id: pulumi.Input[str],
                 connected_cloudspace_id: pulumi.Input[str],
                 customer_id: pulumi.Input[str],
                 local_cloudspace_ip_: pulumi.Input[str],
                 remote_cloudspace_ip_: pulumi.Input[str],
                 token: pulumi.Input[str],
                 url: pulumi.Input[str]):
        """
        The set of arguments for constructing a ConnectedCloudspace resource.
        """
        pulumi.set(__self__, "cloudspace_id", cloudspace_id)
        pulumi.set(__self__, "connected_cloudspace_id", connected_cloudspace_id)
        pulumi.set(__self__, "customer_id", customer_id)
        pulumi.set(__self__, "local_cloudspace_ip_", local_cloudspace_ip_)
        pulumi.set(__self__, "remote_cloudspace_ip_", remote_cloudspace_ip_)
        pulumi.set(__self__, "token", token)
        pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter
    def cloudspace_id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "cloudspace_id")

    @cloudspace_id.setter
    def cloudspace_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "cloudspace_id", value)

    @property
    @pulumi.getter
    def connected_cloudspace_id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "connected_cloudspace_id")

    @connected_cloudspace_id.setter
    def connected_cloudspace_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "connected_cloudspace_id", value)

    @property
    @pulumi.getter(name="customerID")
    def customer_id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "customer_id")

    @customer_id.setter
    def customer_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "customer_id", value)

    @property
    @pulumi.getter(name="local_cloudspace_ip ")
    def local_cloudspace_ip_(self) -> pulumi.Input[str]:
        return pulumi.get(self, "local_cloudspace_ip_")

    @local_cloudspace_ip_.setter
    def local_cloudspace_ip_(self, value: pulumi.Input[str]):
        pulumi.set(self, "local_cloudspace_ip_", value)

    @property
    @pulumi.getter(name="remote_cloudspace_ip ")
    def remote_cloudspace_ip_(self) -> pulumi.Input[str]:
        return pulumi.get(self, "remote_cloudspace_ip_")

    @remote_cloudspace_ip_.setter
    def remote_cloudspace_ip_(self, value: pulumi.Input[str]):
        pulumi.set(self, "remote_cloudspace_ip_", value)

    @property
    @pulumi.getter
    def token(self) -> pulumi.Input[str]:
        return pulumi.get(self, "token")

    @token.setter
    def token(self, value: pulumi.Input[str]):
        pulumi.set(self, "token", value)

    @property
    @pulumi.getter
    def url(self) -> pulumi.Input[str]:
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: pulumi.Input[str]):
        pulumi.set(self, "url", value)


class ConnectedCloudspace(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cloudspace_id: Optional[pulumi.Input[str]] = None,
                 connected_cloudspace_id: Optional[pulumi.Input[str]] = None,
                 customer_id: Optional[pulumi.Input[str]] = None,
                 local_cloudspace_ip_: Optional[pulumi.Input[str]] = None,
                 remote_cloudspace_ip_: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a ConnectedCloudspace resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConnectedCloudspaceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a ConnectedCloudspace resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ConnectedCloudspaceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConnectedCloudspaceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cloudspace_id: Optional[pulumi.Input[str]] = None,
                 connected_cloudspace_id: Optional[pulumi.Input[str]] = None,
                 customer_id: Optional[pulumi.Input[str]] = None,
                 local_cloudspace_ip_: Optional[pulumi.Input[str]] = None,
                 remote_cloudspace_ip_: Optional[pulumi.Input[str]] = None,
                 token: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConnectedCloudspaceArgs.__new__(ConnectedCloudspaceArgs)

            if cloudspace_id is None and not opts.urn:
                raise TypeError("Missing required property 'cloudspace_id'")
            __props__.__dict__["cloudspace_id"] = cloudspace_id
            if connected_cloudspace_id is None and not opts.urn:
                raise TypeError("Missing required property 'connected_cloudspace_id'")
            __props__.__dict__["connected_cloudspace_id"] = connected_cloudspace_id
            if customer_id is None and not opts.urn:
                raise TypeError("Missing required property 'customer_id'")
            __props__.__dict__["customer_id"] = customer_id
            if local_cloudspace_ip_ is None and not opts.urn:
                raise TypeError("Missing required property 'local_cloudspace_ip_'")
            __props__.__dict__["local_cloudspace_ip_"] = local_cloudspace_ip_
            if remote_cloudspace_ip_ is None and not opts.urn:
                raise TypeError("Missing required property 'remote_cloudspace_ip_'")
            __props__.__dict__["remote_cloudspace_ip_"] = remote_cloudspace_ip_
            if token is None and not opts.urn:
                raise TypeError("Missing required property 'token'")
            __props__.__dict__["token"] = token
            if url is None and not opts.urn:
                raise TypeError("Missing required property 'url'")
            __props__.__dict__["url"] = url
            __props__.__dict__["local_cloudspace_ip"] = None
            __props__.__dict__["remote_cloudspace_ip"] = None
            __props__.__dict__["status"] = None
        super(ConnectedCloudspace, __self__).__init__(
            'vco:resources:ConnectedCloudspace',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'ConnectedCloudspace':
        """
        Get an existing ConnectedCloudspace resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ConnectedCloudspaceArgs.__new__(ConnectedCloudspaceArgs)

        __props__.__dict__["cloudspace_id"] = None
        __props__.__dict__["connected_cloudspace_id"] = None
        __props__.__dict__["customer_id"] = None
        __props__.__dict__["local_cloudspace_ip"] = None
        __props__.__dict__["remote_cloudspace_ip"] = None
        __props__.__dict__["status"] = None
        __props__.__dict__["token"] = None
        __props__.__dict__["url"] = None
        return ConnectedCloudspace(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def cloudspace_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "cloudspace_id")

    @property
    @pulumi.getter
    def connected_cloudspace_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "connected_cloudspace_id")

    @property
    @pulumi.getter(name="customerID")
    def customer_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "customer_id")

    @property
    @pulumi.getter
    def local_cloudspace_ip(self) -> pulumi.Output[str]:
        return pulumi.get(self, "local_cloudspace_ip")

    @property
    @pulumi.getter
    def remote_cloudspace_ip(self) -> pulumi.Output[str]:
        return pulumi.get(self, "remote_cloudspace_ip")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def token(self) -> pulumi.Output[str]:
        return pulumi.get(self, "token")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[str]:
        return pulumi.get(self, "url")

